// torus testfile, CSG testfile

#include "surfs.inc"

camera { 
  location <-1, 0, -4>
  look_at <0, 0, 0>
  fov 40
}

options { 
  tolerance 0.2		// needed for the cubic_cylinder
}

object {
  light_source { <-10, 10, -20> color red 1.0 blue 1.0 green 1.0 }
}

#declare ShinyBlue  =  texture {
  ambient color blue 0.2
  diffuse color blue 0.7 red 0.2 green 0.2
  specular color rgb <0.4, 0.4, 0.4>
  roughness 0.1
}

#declare algcsg1 = object {
  intersection {
    algebraic { $x^4+y^4+z^4 = 1 $ closed }
    algebraic { $x^4+y^4+z^4 = 1 $ closed inverse scale <0.5> }
    plane { <1, 0, 0>, 0 }
  }
  texture { ShinyBlue }
  rotate <0, 45, 0>
}


// try rayce -d16 with this one.
#declare algcsg2 = object {
  intersection {
   algebraic { Cubic_Cylinder inverse sturm } 
   sphere { <0,0,0>, 1 } 
  }
  texture { ShinyBlue }
  rotate <0, 20, 0>
}




