// testfile by George Kyriazis

#include "colors.inc"

camera {
  location <1, 0, -2>
  direction <-0.5, 0, 1>
  sky <0, 1, 0>
  fov 50
}

#declare darkgrey = color red 0.1 green 0.1 blue 0.1
#declare dark2grey = color red 0.2 green 0.2 blue 0.2

options {
  time 0, 0.3
  background color red 0.2 green 0.2 blue 0.2
  iterations 10
}

#declare lt = 
object {
  light_source { <1, 3, 0> color White }
}


#declare sph1 = 
object {
  sphere {
    <-1, 0.5, 1.5>, 0.95
  }
  texture {
    ambient color darkgrey
    diffuse color red 0.1 green 0.1
    specular color red 0.3 green 0.3 blue 0.1
    reflection color red 1 green 1 blue 0.4
    reflection 0.6
    refraction color red 1 green 1 blue 1
    refraction 0.2
    roughness 0.012
    ior 1.3
  }
  speed <0, 1, 1>
}

#declare  sph2 = 
object {
  sphere { <0.5, -0.3, 1.2>, 0.7 }
  texture {
    ambient color red 0.1 green 0.1
    specular color red 0.1
    reflection color red 1 green 1 blue 0.2
    reflection 0.1
    refraction color red 1 green 1 blue 1
    refraction 0.75
    roughness 0.05
    ior 1.5
    refract_angle 1
  }
}

#declare sq =
object {
  polygon { <-3, -1, -1>, <3, -1, -1>, <3, -1, 7>, <-3, -1, 7> }
  texture {
    diffuse color green 0.2
    reflection color red 0.5 green 0.5 blue 0.9
    reflection 0.5
    roughness 0.025
    reflect_angle 5
  }
}

object { lt }
object { sq }
object { sph1 }
object { sph2 }

