// testfile by George Kyriazis

#include "colors.inc"

camera {
  fov 85
  aspect 1.333
  location <2.5, -0.5, -2>
  direction <-1, 0, 1>
  sky <0, 1, 0.4>
}

options {
  background y color red 0.2 green 0.2 blue 0.2
  iterations 1
  time 0.0, 0.2
}

#declare light = object {
  light_source { <-5, 2, 3> color rgb <1.6> }
}

object { light }

#declare beauty = object {
  sphere { <-0.4, -0.3, 2.6>, 1 }
  texture {
    ambient color red 0.0 green 0.1 blue 0.1
    diffuse color red 0.0 green 0.1 blue 0.1
    specular color red 0.1 green 0.3 blue 0.3
    reflection color red 1 green 1 blue 0.3
    reflection 0.5
    roughness 0.01
  }
  speed <1, 0, 0>
}

#declare table = object {
  polygon { <-5, -2, -1>, <-5, -2, 5>, <5, -2, 5>, <5, -2, -1> }
  texture {
    ambient color red 0.1 green 0.1 blue 0.1
    diffuse color red 0.5
    specular color red 0.9
    reflection color red 0.5 green 0.5 blue 0.5
    reflection 0.5
    roughness 0.1
    reflect_angle 14
  }
}

#declare mirror = object {
  polygon { <-1.5, -2, 0>, <-1.5, -2, 1.9>, <-1.5, 1, 1.9>, <-1.5, 1, 0> }
  texture {
    ambient color red 0.1 green 0.1 blue 0.4
    diffuse color red 0.1 green 0.1 blue 0.4
    specular color red 0.1 green 0.1 blue 0.1
    reflection color red 1 green 1 blue 0.1
    roughness 1
  }
}

object { beauty }
object { mirror }
object { table }
